# Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

# * The software is provided "as is" without any warranty, neither express
#   nor implied.
# * In no event will the author be held liable for any damage(s) arising
#   from the use of the software.
# * Redistribution of the software is allowed only in unmodified form.
# * Permission is granted to use the software solely for personal private
#   and non-commercial purposes.
# * An individuals use of the software in his or her capacity or function
#   as an agent, (independent) contractor, employee, member or officer of
#   a business, corporation or organization (commercial or non-commercial)
#   does not qualify as personal private and non-commercial purpose.
# * Without written approval from the author the software must not be used
#   for a business, for commercial, corporate, governmental, military or
#   organizational purposes of any kind, or in a commercial, corporate,
#   governmental, military or organizational environment of any kind.

.SUFFIXES:

ext_attr: EXT_ATTR.DOS EXT_ATTR.COM EXT_ATTR.EXE

clean:
	ERASE EXT_ATTR.DOS EXT_ATTR.EXP EXT_ATTR.LIB EXT_ATTR.OBJ EXT_ATTR.TMP EXT_ATTR.XYZ

clobber: clean
	ERASE EXT_ATTR.COM EXT_ATTR.EXE

EXT_ATTR.LIB:: EXT_ATTR.TMP
	LINK.EXE /LIB /BREPRO /DEF /EXPORT:NtClose /EXPORT:NtCreateFile /EXPORT:NtOpenFile /EXPORT:NtQueryEaFile /EXPORT:NtQueryInformationFile /EXPORT:NtSetEaFile /EXPORT:NtSetInformationFile /EXPORT:RtlAllocateHeap /EXPORT:RtlDosPathNameToNtPathName_U_WithStatus /EXPORT:RtlFreeHeap /EXPORT:RtlFreeUnicodeString /EXPORT:RtlSetLastWin32ErrorAndNtStatusFromNtStatus /NAME:NTDLL /NODEFAULTLIB /NOLOGO /OUT:$@ $**

EXT_ATTR.TMP: EXT_ATTR.MAK
	CL.EXE /Brepro /c /Fo$@ /Gz /nologo /Tc<< /W4 /wd4100 /X /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/ms648410.aspx

__declspec(dllexport)
long	NtClose(void *_1)
{ return 0; }

// https://msdn.microsoft.com/en-us/library/bb432380.aspx

__declspec(dllexport)
long	NtCreateFile(void *_1, long _2, void *_3, void *_4, void *_5, long _6, long _7, long _8, long _9, void *_10, long _11)
{ return 0; }

// https://msdn.microsoft.com/en-us/library/bb432381.aspx

__declspec(dllexport)
long	NtOpenFile(void *_1, long _2, void *_3, void *_4, long _5, long _6)
{ return 0; }

// https://msdn.microsoft.com/en-us/library/ff625894.aspx
// https://msdn.microsoft.com/en-us/library/ff961907.aspx

__declspec(dllexport)
long	NtQueryEaFile(void *_1, void *_2, void *_3, long _4, long _5, void *_6, long _7, void *_8, long _9)
{ return 0; }

// https://msdn.microsoft.com/en-us/library/ff556646.aspx
// https://msdn.microsoft.com/en-us/library/ff567052.aspx

__declspec(dllexport)
long	NtQueryInformationFile(void *_1, void *_2, void *_3, long _4, long _5)
{ return 0; }

// https://msdn.microsoft.com/en-us/library/ff961908.aspx

__declspec(dllexport)
long	NtSetEaFile(void *_1, void *_2, void *_3, long _4)
{ return 0; }

// https://msdn.microsoft.com/en-us/library/ff557671.aspx
// https://msdn.microsoft.com/en-us/library/ff567096.aspx

__declspec(dllexport)
long	NtSetInformationFile(void *_1, void *_2, void *_3, long _4, long _5)
{ return 0; }

// https://msdn.microsoft.com/en-us/library/ff552108.aspx

__declspec(dllexport)
void	*RtlAllocateHeap(void *_1, long _2, void *_3)
{ return 0; }

__declspec(dllexport)
long	RtlDosPathNameToNtPathName_U_WithStatus(void *_1, void *_2, void *_3, void *_4)
{ return 0; }

// https://msdn.microsoft.com/en-us/library/mt723417.aspx

__declspec(dllexport)
long	RtlFreeHeap(void *_1, long _2, void *_3)
{ return 0; }

// https://msdn.microsoft.com/en-us/library/ms648418.aspx

__declspec(dllexport)
void	RtlFreeUnicodeString(void *_1)
{}

__declspec(dllexport)
void	RtlSetLastWin32ErrorAndNtStatusFromNtStatus(long _1)
{}
<<NOKEEP

EXT_ATTR.LIB:: EXT_ATTR.OBJ
	LINK.EXE /LIB /BREPRO /NODEFAULTLIB /NOLOGO /OUT:$@ $@ $**

EXT_ATTR.OBJ: EXT_ATTR.MAK
	CL.EXE /analyze /Brepro /c /Fo$@ /GA /GF /Gw /Gy /nologo /Ox /Oy /Tc<< /W4 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)
#pragma comment(lib, "ext_attr")

// https://msdn.microsoft.com/en-us/library/tzkfha43.aspx

#pragma intrinsic(__movsb, strlen)

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

#define FILE_SHARE_NONE			0UL
#define FILE_OPEN			1UL
#define FILE_OPENED			1UL
#define FILE_CREATE			2UL
#define FILE_CREATED			2UL
#define FILE_OPEN_IF			3UL
#define FILE_DIRECTORY_FILE		0x00000001UL
#define FILE_SYNCHRONOUS_IO_NONALERT	0x00000020UL
#define FILE_OPEN_FOR_BACKUP_INTENT	0x00004000UL

// https://msdn.microsoft.com/en-us/library/ff557749.aspx

#define OBJ_CASE_INSENSITIVE	64UL

#define STATUS_SUCCESS			0L
#define STATUS_BUFFER_OVERFLOW		0x80000005L
#define STATUS_NO_MORE_EAS		0x80000012L
#define STATUS_INVALID_EA_NAME		0x80000013L
#define STATUS_EA_LIST_INCONSISTENT	0x80000014L
#define STATUS_INVALID_EA_FLAG		0x80000015L
#define STATUS_BUFFER_TOO_SMALL		0xC0000023L
#define STATUS_EAS_NOT_SUPPORTED	0xC000004FL
#define STATUS_EA_TOO_LARGE		0xC0000050L
#define STATUS_NONEXISTENT_EA_ENTRY	0xC0000051L
#define STATUS_NO_EAS_ON_FILE		0xC0000052L
#define STATUS_EA_CORRUPT_ERROR		0xC0000053L
#define STATUS_INSUFFICIENT_RESOURCES	0xC000009AL

typedef	LONG	NTSTATUS;

// https://msdn.microsoft.com/en-us/library/ff728840.aspx

typedef	enum	_FILE_INFORMATION_CLASS
{
	FileEaInformation     = 7,
	FileFullEaInformation = 15
} FILE_INFORMATION_CLASS;

// https://msdn.microsoft.com/en-us/library/ff545773.aspx

typedef	struct	_FILE_EA_INFORMATION
{
	DWORD	EaSize;
} FILE_EA_INFORMATION;

// https://msdn.microsoft.com/en-us/library/2e70t5y1.aspx

#pragma pack(push, 1)

// https://msdn.microsoft.com/en-us/library/ff540295.aspx

typedef	struct	_FILE_GET_EA_INFORMATION
{
	DWORD	NextEntryOffset;
	BYTE	EaNameLength;
	CHAR	EaName[256];
} FILE_GET_EA_INFORMATION;

// https://msdn.microsoft.com/en-us/library/ff545793.aspx

typedef	struct	_FILE_FULL_EA_INFORMATION
{
	DWORD	NextEntryOffset;
	BYTE	Flags;
	BYTE	EaNameLength;
	WORD	EaValueLength;
	CHAR	EaName[1];
//	BYTE	EaValue[1];
} FILE_FULL_EA_INFORMATION;

// https://msdn.microsoft.com/en-us/library/2e70t5y1.aspx

#pragma pack(pop)

// https://msdn.microsoft.com/en-us/library/aa380518.aspx

typedef	struct	_UNICODE_STRING
{
	WORD	Length;
	WORD	MaximumLength;
	LPWSTR	Buffer;
} UNICODE_STRING;

// https://msdn.microsoft.com/en-us/library/ff557749.aspx

typedef	struct	_OBJECT_ATTRIBUTES
{
	DWORD		Length;
	HANDLE		RootDirectory;
	UNICODE_STRING	*ObjectName;
	DWORD		Attributes;
	LPVOID		SecurityDescriptor;
	LPVOID		SecurityQualityOfService;
} OBJECT_ATTRIBUTES;

// https://msdn.microsoft.com/en-us/library/ff550671.aspx

typedef	struct	_IO_STATUS_BLOCK
{
	union
	{
		LONG	Status;
		LPVOID	Pointer;
	};
	DWORD_PTR	Information;
} IO_STATUS_BLOCK;

typedef	struct	_RTLP_CURDIR_REF
{
	LONG	RefCount;
	HANDLE	Handle;
} RTLP_CURDIR_REF;

typedef	struct	_RTL_RELATIVE_NAME_U
{
	UNICODE_STRING	RelativeName;
	HANDLE		ContainingDirectory;
	RTLP_CURDIR_REF	*CurDirRef;
} RTL_RELATIVE_NAME_U;

// https://msdn.microsoft.com/en-us/library/aa813741.aspx

typedef	struct	_RTL_USER_PROCESS_PARAMETERS
{
	BYTE		Reserved1[16];
	LPVOID		Reserved2[10];
	UNICODE_STRING	ImagePathName;
	UNICODE_STRING	CommandLine;
} RTL_USER_PROCESS_PARAMETERS;

// https://msdn.microsoft.com/en-us/library/aa813708.aspx

typedef	struct	_PEB_LDR_DATA
{
	BYTE		Reserved1[8];
	LPVOID		Reserved2[3];
	LIST_ENTRY	InMemoryOrderModuleList;
} PEB_LDR_DATA;

typedef	VOID	(NTAPI	PS_POST_PROCESS_INIT_ROUTINE) (VOID);

// https://msdn.microsoft.com/en-us/library/aa813706.aspx

typedef	struct	_PEB
{
	BYTE				Reserved1[2];
	BOOLEAN				BeingDebugged;
	BYTE				Reserved2[1];
	LPVOID				Reserved3[2];
	PEB_LDR_DATA			*Ldr;
	RTL_USER_PROCESS_PARAMETERS	*ProcessParameters;
#if 0
	LPVOID				Reserved4[3];
#else
	LPVOID				SubSystemData;
	HANDLE				ProcessHeap;
	RTL_CRITICAL_SECTION		*FastPebLock;
#endif
	LPVOID				AtlThunkSListPtr;
	LPVOID				Reserved5;
	DWORD				Reserved6;
	LPVOID				Reserved7;
	DWORD				Reserved8;
	DWORD				AtlThunkSListPtr32;
	LPVOID				Reserved9[45];
	BYTE				Reserved10[96];
	PS_POST_PROCESS_INIT_ROUTINE	*PostProcessInitRoutine;
	BYTE				Reserved11[128];
	LPVOID				Reserved12[1];
	DWORD				SessionId;
} PEB;

// https://msdn.microsoft.com/en-us/library/ms686708.aspx

typedef	struct	_TEB
{
	LPVOID		Reserved1[12];
	PEB		*ProcessEnvironmentBlock;
	LPVOID		Reserved2[399];
	BYTE		Reserved3[1952];
	LPVOID		TlsSlots[64];
	LIST_ENTRY	TlsLinks;
	LPVOID		Reserved5[26];
	LPVOID		ReservedForOle;
	LPVOID		Reserved6[4];
	LPVOID		*TlsExpansionSlots;
} TEB;

// https://msdn.microsoft.com/en-us/library/ms648410.aspx

__declspec(dllimport)
LONG	NTAPI	NtClose(HANDLE Handle);

// https://msdn.microsoft.com/en-us/library/bb432380.aspx

__declspec(dllimport)
LONG	NTAPI	NtCreateFile(HANDLE                   *FileHandle,
		             ACCESS_MASK              DesiredAccess,
		             OBJECT_ATTRIBUTES        *ObjectAttributes,
		             IO_STATUS_BLOCK          *IoStatusBlock,
		             LARGE_INTEGER            *AllocationSize,
		             DWORD                    FileAttributes,
		             DWORD                    ShareAccess,
		             DWORD                    CreateDisposition,
		             DWORD                    CreateOptions,
		             FILE_FULL_EA_INFORMATION *EaBuffer,
		             DWORD                    EaLength);

// https://msdn.microsoft.com/en-us/library/bb432381.aspx

__declspec(dllimport)
LONG	NTAPI	NtOpenFile(HANDLE            *FileHandle,
		           ACCESS_MASK       DesiredAccess,
		           OBJECT_ATTRIBUTES *ObjectAttributes,
		           IO_STATUS_BLOCK   *IoStatusBlock,
		           DWORD             ShareAccess,
		           DWORD             OpenOptions);

// https://msdn.microsoft.com/en-us/library/ff625894.aspx

__declspec(dllimport)
LONG	NTAPI	NtQueryEaFile(HANDLE                   FileHandle,
		              IO_STATUS_BLOCK          *IoStatusBlock,
		              FILE_FULL_EA_INFORMATION *EaBuffer,
		              DWORD                    EaBufferLength,
		              BOOLEAN                  ReturnSingleEntry,
		              FILE_GET_EA_INFORMATION  *EaList,
		              DWORD                    EaListLength,
		              LPDWORD                  EaIndex,
		              BOOLEAN                  RestartScan);

// https://msdn.microsoft.com/en-us/library/ff556646.aspx
// https://msdn.microsoft.com/en-us/library/ff567052.aspx

__declspec(dllimport)
LONG	NTAPI	NtQueryInformationFile(HANDLE                 FileHandle,
		                       IO_STATUS_BLOCK        *IoStatusBlock,
		                       VOID                   *FileInformation,
		                       DWORD                  FileInformationLength,
		                       FILE_INFORMATION_CLASS FileInformationClass);

// https://msdn.microsoft.com/en-us/library/ff961908.aspx

__declspec(dllimport)
LONG	NTAPI	NtSetEaFile(HANDLE          FileHandle,
		            IO_STATUS_BLOCK *IoStatusBlock,
		            VOID            *Buffer,
		            DWORD           Length);

// https://msdn.microsoft.com/en-us/library/ff557671.aspx
// https://msdn.microsoft.com/en-us/library/ff567096.aspx

__declspec(dllimport)
LONG	NTAPI	NtSetInformationFile(HANDLE                 FileHandle,
		                     IO_STATUS_BLOCK        *IoStatusBlock,
		                     VOID                   *FileInformation,
		                     DWORD                  FileInformationLength,
		                     FILE_INFORMATION_CLASS FileInformationClass);

// https://msdn.microsoft.com/en-us/library/ff552108.aspx

__declspec(dllimport)
LPVOID	NTAPI	RtlAllocateHeap(LPCVOID HeapHandle,
		                DWORD   Flags,
		                SIZE_T  Size);
__declspec(dllimport)
LONG	NTAPI	RtlDosPathNameToNtPathName_U_WithStatus(LPCWSTR             DosName,
		                                        UNICODE_STRING      *NtName,
		                                        LPCWSTR             *PartName,
		                                        RTL_RELATIVE_NAME_U *RelativeName);

// https://msdn.microsoft.com/en-us/library/mt723417.aspx

__declspec(dllimport)
BOOL	NTAPI	RtlFreeHeap(LPCVOID HeapHandle,
		            DWORD   Flags,
		            LPCVOID HeapBase);

// https://msdn.microsoft.com/en-us/library/ms648418.aspx

__declspec(dllimport)
VOID	NTAPI	RtlFreeUnicodeString(UNICODE_STRING *UnicodeString);

__declspec(dllimport)
VOID	NTAPI	RtlSetLastWin32ErrorAndNtStatusFromNtStatus(NTSTATUS Status);

BOOL	WINAPI	FreeExtendedFileAttributes(LPCVOID lpBlock)
{
	// https://msdn.microsoft.com/en-us/library/hh285210.aspx

	LPCVOID	lpHeap = NtCurrentTeb()->ProcessEnvironmentBlock->ProcessHeap;

	LONG	ntStatus = STATUS_INVALID_PARAMETER;

	if (lpBlock != NULL)
		return RtlFreeHeap(lpHeap, 0UL, lpBlock);

	RtlSetLastWin32ErrorAndNtStatusFromNtStatus(ntStatus);

	return FALSE;
}

LPCVOID	WINAPI	GetExtendedFileAttributesW(LPCWSTR lpSource)
{
	// https://msdn.microsoft.com/en-us/library/hh285210.aspx

	LPCVOID	lpHeap = NtCurrentTeb()->ProcessEnvironmentBlock->ProcessHeap;

	LONG	ntStatus = STATUS_INVALID_PARAMETER;
	DWORD	dwSource;
	HANDLE	hSource;

	IO_STATUS_BLOCK		ioSource;
	UNICODE_STRING		usSource;
	OBJECT_ATTRIBUTES	oaSource = {sizeof(oaSource),
				            (HANDLE) NULL,
				            (UNICODE_STRING *) NULL,
				            OBJ_CASE_INSENSITIVE,
				            NULL,
				            NULL};

	FILE_FULL_EA_INFORMATION	*eaSource = NULL;

	if (lpSource != NULL && *lpSource != L'\0')
	{
		ntStatus = RtlDosPathNameToNtPathName_U_WithStatus(lpSource,
		                                                   &usSource,
		                                                   (LPCWSTR *) NULL,
		                                                   NULL);
		if (ntStatus == STATUS_SUCCESS)
		{
			oaSource.ObjectName = &usSource;

			ntStatus = NtOpenFile(&hSource,
			                      FILE_READ_EA | SYNCHRONIZE,
			                      &oaSource,
			                      &ioSource,
			                      FILE_SHARE_NONE,
			                      FILE_SYNCHRONOUS_IO_NONALERT);

			RtlFreeUnicodeString(&usSource);

			if (ntStatus == STATUS_SUCCESS)
			{
				ntStatus = NtQueryInformationFile(hSource,
				                                  &ioSource,
				                                  &dwSource,
				                                  sizeof(dwSource),
				                                  FileEaInformation);
				if (ntStatus == STATUS_SUCCESS)
					if (dwSource == 0UL)
						ntStatus = STATUS_NO_EAS_ON_FILE;
					else
					{
#if 0 // CAVEAT: NtQueryInformationFile() returns
      //          for FileEaInformation a value
      //           (number of EAs - 1) * 4 lower
      //            than the required buffer size!
						eaSource = RtlAllocateHeap(lpHeap, 0UL, dwSource);
#else
						eaSource = RtlAllocateHeap(lpHeap, 0UL, dwSource = 65536UL);
#endif
						if (eaSource == NULL)
							ntStatus = STATUS_INSUFFICIENT_RESOURCES;
						else
						{
#if 0 // CAVEAT: NtQueryInformationFile() fails
      //          with STATUS_NOT_IMPLEMENTED
      //           for FileFullEaInformation!
							ntStatus = NtQueryInformationFile(hSource,
							                                  &ioSource,
							                                  eaSource,
							                                  dwSource,
							                                  FileFullEaInformation);
#else
							ntStatus = NtQueryEaFile(hSource,
							                         &ioSource,
							                         eaSource,
							                         dwSource,
							                         FALSE,
							                         (FILE_GET_EA_INFORMATION *) NULL,
							                         0UL,
							                         (LPDWORD) NULL,
							                         TRUE);
#endif
							if (ntStatus != STATUS_SUCCESS)
							{
								RtlFreeHeap(lpHeap, 0UL, eaSource);

								eaSource = NULL;
							}
						}
					}

				NtClose(hSource);
			}
		}
	}

	if (eaSource == NULL)
		RtlSetLastWin32ErrorAndNtStatusFromNtStatus(ntStatus);

	return eaSource;
}

// https://msdn.microsoft.com/en-us/library/hh916382.aspx

__declspec(safebuffers)
DWORD	WINAPI	GetExtendedFileAttributeW(LPCWSTR lpSource,
		                          LPCSTR  lpEaName,
		                          LPVOID  lpEaValue,
		                          DWORD   dwEaValue)
{
	// https://msdn.microsoft.com/en-us/library/hh285210.aspx

	LPCVOID	lpHeap = NtCurrentTeb()->ProcessEnvironmentBlock->ProcessHeap;

	LONG	ntStatus = STATUS_INVALID_PARAMETER;
	DWORD	dwEaName;
	DWORD	dwSource = 0UL;
	HANDLE	hSource;

	IO_STATUS_BLOCK		ioSource;
	UNICODE_STRING		usSource;
	OBJECT_ATTRIBUTES	oaSource = {sizeof(oaSource),
				            (HANDLE) NULL,
				            (UNICODE_STRING *) NULL,
				            OBJ_CASE_INSENSITIVE,
				            NULL,
				            NULL};

	FILE_GET_EA_INFORMATION		eaQuery;
	FILE_FULL_EA_INFORMATION	*eaSource;

	if (lpSource != NULL && *lpSource != L'\0'
	 && lpEaName != NULL && *lpEaName != '\0'
	 && (dwEaName = strlen(lpEaName)) < 256UL
	 && (dwEaValue == 0UL || dwEaValue != 0UL && lpEaValue != NULL))
	{
		ntStatus = RtlDosPathNameToNtPathName_U_WithStatus(lpSource,
		                                                   &usSource,
		                                                   (LPCWSTR *) NULL,
		                                                   NULL);
		if (ntStatus == STATUS_SUCCESS)
		{
			oaSource.ObjectName = &usSource;

			ntStatus = NtOpenFile(&hSource,
			                      FILE_READ_EA | SYNCHRONIZE,
			                      &oaSource,
			                      &ioSource,
			                      FILE_SHARE_NONE,
			                      FILE_SYNCHRONOUS_IO_NONALERT);

			RtlFreeUnicodeString(&usSource);

			if (ntStatus == STATUS_SUCCESS)
			{
				eaSource = RtlAllocateHeap(lpHeap, 0UL, 65536UL);

				if (eaSource == NULL)
					ntStatus = STATUS_INSUFFICIENT_RESOURCES;
				else
				{
					eaQuery.NextEntryOffset = 0UL;
					eaQuery.EaNameLength = (BYTE) dwEaName;

					// https://msdn.microsoft.com/en-us/library/hhta9830.aspx

					__movsb(eaQuery.EaName, lpEaName, dwEaName + 1UL);

					ntStatus = NtQueryEaFile(hSource,
					                         &ioSource,
					                         eaSource,
					                         65536UL,
					                         TRUE,
					                         &eaQuery,
					                         sizeof(eaQuery),
					                         (LPDWORD) NULL,
					                         TRUE);

					if (ntStatus == STATUS_SUCCESS)
					{
						dwSource = eaSource->EaValueLength;

						if (dwSource > dwEaValue)
							ntStatus = STATUS_BUFFER_TOO_SMALL;
						else if (dwSource == 0UL)
							ntStatus = STATUS_NONEXISTENT_EA_ENTRY;
						else if (lpEaValue != NULL)
							__movsb(lpEaValue,
							        eaSource->EaName + eaSource->EaNameLength + 1,
							        eaSource->EaValueLength);
					}

					RtlFreeHeap(lpHeap, 0UL, eaSource);
				}

				NtClose(hSource);
			}
		}
	}

	if (dwSource == 0UL)
		RtlSetLastWin32ErrorAndNtStatusFromNtStatus(ntStatus);

	return dwSource;
}

// https://msdn.microsoft.com/en-us/library/hh916382.aspx

__declspec(safebuffers)
DWORD	WINAPI	GetExtendedFileAttributeA(LPCSTR lpSource,
		                          LPCSTR lpEaName,
		                          LPVOID lpEaValue,
		                          DWORD  dwEaValue)
{
	DWORD	dwSource = 0UL;
	WCHAR	szSource[MAX_PATH];

	if (lpSource == NULL || *lpSource == '\0'
	 || lpEaName == NULL || *lpEaName == '\0' || strlen(lpEaName) > 255UL
	 || lpEaValue == NULL && dwEaValue != 0UL)

		// https://msdn.microsoft.com/en-us/library/ms680627.aspx

		SetLastError(ERROR_INVALID_PARAMETER);
	else
		// https://msdn.microsoft.com/en-us/library/ms776413.aspx
		// https://msdn.microsoft.com/en-us/library/dd319072.aspx
		// https://msdn.microsoft.com/en-us/library/ms776446.aspx
		// https://msdn.microsoft.com/en-us/library/dd317756.aspx

		if (MultiByteToWideChar(CP_ACP,
		                        MB_ERR_INVALID_CHARS | MB_PRECOMPOSED,
		                        lpSource, -1,
		                        szSource, sizeof(szSource) / sizeof(*szSource)) > 0)
			dwSource = GetExtendedFileAttributeW(szSource, lpEaName, lpEaValue, dwEaValue);
	return dwSource;
}

// https://msdn.microsoft.com/en-us/library/hh916382.aspx

__declspec(safebuffers)
LPCVOID	WINAPI	GetExtendedFileAttributesA(LPCSTR lpSource)
{
	LPCVOID	eaSource = NULL;
	WCHAR	szSource[MAX_PATH];

	if (lpSource == NULL || *lpSource == '\0')

		// https://msdn.microsoft.com/en-us/library/ms680627.aspx

		SetLastError(ERROR_INVALID_PARAMETER);
	else
		// https://msdn.microsoft.com/en-us/library/ms776413.aspx
		// https://msdn.microsoft.com/en-us/library/dd319072.aspx
		// https://msdn.microsoft.com/en-us/library/ms776446.aspx
		// https://msdn.microsoft.com/en-us/library/dd317756.aspx

		if (MultiByteToWideChar(CP_ACP,
		                        MB_ERR_INVALID_CHARS | MB_PRECOMPOSED,
		                        lpSource, -1,
		                        szSource, sizeof(szSource) / sizeof(*szSource)) > 0)
			eaSource = GetExtendedFileAttributesW(szSource);
		else
			// https://msdn.microsoft.com/en-us/library/ms679360.aspx

			if (GetLastError() == ERROR_INSUFFICIENT_BUFFER)
				SetLastError(ERROR_BUFFER_OVERFLOW);
	return eaSource;
}

BOOL	WINAPI	SetExtendedFileAttributeW(LPCWSTR lpTarget,
		                          LPCSTR  lpEaName,
		                          LPCVOID lpEaValue,
		                          DWORD   dwEaValue)
{
	// https://msdn.microsoft.com/en-us/library/hh285210.aspx

	LPCVOID	lpHeap = NtCurrentTeb()->ProcessEnvironmentBlock->ProcessHeap;

	LONG	ntStatus = STATUS_INVALID_PARAMETER;
	DWORD	dwEaName;
	DWORD	dwTarget;
	BOOL	bTarget = FALSE;
	HANDLE	hTarget;

	IO_STATUS_BLOCK		ioTarget;
	UNICODE_STRING		usTarget;
	OBJECT_ATTRIBUTES	oaTarget = {sizeof(oaTarget),
				            (HANDLE) NULL,
				            (UNICODE_STRING *) NULL,
				            OBJ_CASE_INSENSITIVE,
				            NULL,
				            NULL};

	FILE_FULL_EA_INFORMATION	*eaTarget;

	if (lpTarget != NULL && *lpTarget != L'\0'
	 && lpEaName != NULL && *lpEaName != '\0'
	 && (dwEaValue == 0UL || dwEaValue != 0UL && lpEaValue != NULL)
	 && (dwEaName = strlen(lpEaName)) < 256UL
	 && (dwTarget = sizeof(*eaTarget) + dwEaName + dwEaValue) < 65536UL)
	{
		eaTarget = RtlAllocateHeap(lpHeap, 0UL, dwTarget);

		if (eaTarget == NULL)
			ntStatus = STATUS_INSUFFICIENT_RESOURCES;
		else
		{
			eaTarget->NextEntryOffset = 0UL;
			eaTarget->Flags = 0;
			eaTarget->EaNameLength = (BYTE) dwEaName;
			eaTarget->EaValueLength = (WORD) dwEaValue;

			// https://msdn.microsoft.com/en-us/library/hhta9830.aspx

			__movsb(eaTarget->EaName, lpEaName, dwEaName + 1UL);
			__movsb(eaTarget->EaName + dwEaName + 1UL, lpEaValue, dwEaValue);

			ntStatus = RtlDosPathNameToNtPathName_U_WithStatus(lpTarget,
			                                                   &usTarget,
			                                                   (LPCWSTR *) NULL,
			                                                   NULL);
			if (ntStatus == STATUS_SUCCESS)
			{
				oaTarget.ObjectName = &usTarget;

				ntStatus = NtCreateFile(&hTarget,
				                        FILE_WRITE_ATTRIBUTES | FILE_WRITE_EA | SYNCHRONIZE,
				                        &oaTarget,
				                        &ioTarget,
				                        (LARGE_INTEGER *) NULL,
#if 0
				                        FILE_ATTRIBUTE_DIRECTORY,
				                        FILE_SHARE_NONE,
				                        FILE_CREATE,
				                        FILE_DIRECTORY_FILE | FILE_SYNCHRONOUS_IO_NONALERT,
#else
				                        FILE_ATTRIBUTE_NORMAL,
				                        FILE_SHARE_NONE,
				                        FILE_OPEN_IF,
				                        FILE_SYNCHRONOUS_IO_NONALERT,
#endif
				                        eaTarget,
				                        dwTarget);

				RtlFreeUnicodeString(&usTarget);

				if (ntStatus == STATUS_SUCCESS)
				{
					if (ioTarget.Information == FILE_CREATED)
						bTarget = TRUE;
					else
					{
#if 0 // CAVEAT: NtSetInformationFile() fails
      //          with STATUS_INVALID_INFO_CLASS
      //           for FileFullEaInformation!
						ntStatus = NtSetInformationFile(hTarget,
						                                &ioTarget,
						                                eaTarget,
						                                dwTarget,
						                                FileFullEaInformation);
#else
						ntStatus = NtSetEaFile(hTarget,
						                       &ioTarget,
						                       eaTarget,
						                       dwTarget);
#endif
						if (ntStatus == STATUS_SUCCESS)
							bTarget = TRUE;
					}

					NtClose(hTarget);
				}
			}

			RtlFreeHeap(lpHeap, 0UL, eaTarget);
		}
	}

	if (!bTarget)
		RtlSetLastWin32ErrorAndNtStatusFromNtStatus(ntStatus);

	return bTarget;
}

// https://msdn.microsoft.com/en-us/library/hh916382.aspx

__declspec(safebuffers)
BOOL	WINAPI	SetExtendedFileAttributeA(LPCSTR  lpTarget,
		                          LPCSTR  lpEaName,
		                          LPCVOID lpEaValue,
		                          DWORD   dwEaValue)
{
	BOOL	bTarget = FALSE;
	WCHAR	szTarget[MAX_PATH];

	if (lpTarget == NULL || *lpTarget == '\0'
	 || lpEaName == NULL || *lpEaName == '\0'
	 || lpEaValue == NULL && dwEaValue != 0UL)

		// https://msdn.microsoft.com/en-us/library/ms680627.aspx

		SetLastError(ERROR_INVALID_PARAMETER);
	else
		// https://msdn.microsoft.com/en-us/library/ms776413.aspx
		// https://msdn.microsoft.com/en-us/library/dd319072.aspx
		// https://msdn.microsoft.com/en-us/library/ms776446.aspx
		// https://msdn.microsoft.com/en-us/library/dd317756.aspx

		if (MultiByteToWideChar(CP_ACP,
		                        MB_ERR_INVALID_CHARS | MB_PRECOMPOSED,
		                        lpTarget, -1,
		                        szTarget, sizeof(szTarget) / sizeof(*szTarget)) > 0)
			bTarget = SetExtendedFileAttributeW(szTarget, lpEaName, lpEaValue, dwEaValue);
		else
			// https://msdn.microsoft.com/en-us/library/ms679360.aspx

			if (GetLastError() == ERROR_INSUFFICIENT_BUFFER)
				SetLastError(ERROR_BUFFER_OVERFLOW);
	return bTarget;
}
<<NOKEEP

EXT_ATTR.COM: EXT_ATTR.XYZ EXT_ATTR.LIB # EXT_ATTR.DOS
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:kernel32 /DEFAULTLIB:user32 /EMITTOOLVERSIONINFO:NO /ENTRY:mainCRTStartup /FIXED /LARGEADDRESSAWARE /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OPT:ICF,REF /OSVERSION:5.0 /OUT:$@ /RELEASE /STUB:EXT_ATTR.DOS /SUBSYSTEM:CONSOLE /SWAPRUN:CD,NET /VERSION:0.815 $**

EXT_ATTR.EXE: EXT_ATTR.XYZ EXT_ATTR.LIB # EXT_ATTR.DOS
	LINK.EXE /LINK /BREPRO /DEFAULTLIB:kernel32 /DEFAULTLIB:user32 /EMITTOOLVERSIONINFO:NO /ENTRY:wmainCRTStartup /FIXED /LARGEADDRESSAWARE /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NOLOGO /NXCOMPAT /OPT:ICF,REF /OSVERSION:5.0 /OUT:$@ /RELEASE /STUB:EXT_ATTR.DOS /SUBSYSTEM:CONSOLE /SWAPRUN:CD,NET /VERSION:0.815 $**

EXT_ATTR.XYZ: EXT_ATTR.MAK
	CL.EXE /Brepro /c /Fo$@ /GA /GF /Gy /nologo /Ox /Oy /Tc<< /W4 /we4013 /Zl
// Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

#define STRICT
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

// https://msdn.microsoft.com/en-us/library/ff545793.aspx

typedef	struct	_FILE_FULL_EA_INFORMATION
{
	DWORD	NextEntryOffset;
	BYTE	Flags;
	BYTE	EaNameLength;
	WORD	EaValueLength;
	CHAR	EaName[ANYSIZE_ARRAY];
} FILE_FULL_EA_INFORMATION;

// https://msdn.microsoft.com/en-us/library/hh916382.aspx

__declspec(safebuffers)
BOOL	CDECL	PrintConsole(HANDLE hConsole, [SA_FormatString(Style="printf")] LPCWSTR lpFormat, ...)
{
	WCHAR	szOutput[1025];
	DWORD	dwOutput;
	DWORD	dwConsole;

	// https://msdn.microsoft.com/en-us/library/kb57fad8.aspx

	va_list	vaInput;
	va_start(vaInput, lpFormat);

	// https://msdn.microsoft.com/en-us/library/ms647551.aspx

	dwOutput = wvsprintfW(szOutput, lpFormat, vaInput);

	va_end(vaInput);

	if (dwOutput == 0UL)
		return FALSE;

	// https://msdn.microsoft.com/en-us/library/ms687401.aspx

	if (!WriteConsoleW(hConsole, szOutput, dwOutput, &dwConsole, NULL))
		return FALSE;

	return dwConsole == dwOutput;
}

BOOL	WINAPI	FreeExtendedFileAttributes(LPCVOID lpBlock);

LPCVOID	WINAPI	GetExtendedFileAttributesA(LPCSTR lpSource);

LPCVOID	WINAPI	GetExtendedFileAttributesW(LPCWSTR lpSource);

DWORD	WINAPI	GetExtendedFileAttributeA(LPCSTR  lpTarget,
		                          LPCSTR  lpEaName,
		                          LPVOID  lpEaValue,
		                          DWORD   dwEaValue);

DWORD	WINAPI	GetExtendedFileAttributeW(LPCWSTR lpTarget,
		                          LPCSTR  lpEaName,
		                          LPVOID  lpEaValue,
		                          DWORD   dwEaValue);

BOOL	WINAPI	SetExtendedFileAttributeA(LPCSTR  lpTarget,
		                          LPCSTR  lpEaName,
		                          LPCVOID lpEaValue,
		                          DWORD   dwEaValue);

BOOL	WINAPI	SetExtendedFileAttributeW(LPCWSTR lpTarget,
		                          LPCSTR  lpEaName,
		                          LPCVOID lpEaValue,
		                          DWORD   dwEaValue);

const	CHAR	szCP1252[] = "\x7F\x81\x8C\x8D\x8E\x8F";

// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

__declspec(noreturn)
VOID	CDECL	mainCRTStartup(VOID)
{
	// https://msdn.microsoft.com/en-us/library/ms682658.aspx
	// https://msdn.microsoft.com/en-us/library/ms679360.aspx

	ExitProcess(SetExtendedFileAttributeA("EXT_ATTR.OMF", "EA Name", "EA Value", sizeof("EA Value")) ? ERROR_SUCCESS : GetLastError());
}

__declspec(noreturn)
VOID	CDECL	wmainCRTStartup(VOID)
{
	FILE_FULL_EA_INFORMATION	*lpEA;

	LPCVOID	lpBlock;
	BOOL	b = FALSE;
	BYTE	cbValue[sizeof("EA Value")];
	DWORD	dwValue;
	DWORD	dwOffset;
	DWORD	dwError = ERROR_SUCCESS;

	// https://msdn.microsoft.com/en-us/library/ms683231.aspx

	HANDLE	hError = GetStdHandle(STD_ERROR_HANDLE);

	if (hError == INVALID_HANDLE_VALUE)
		dwError = GetLastError();
	else
	{
		if (!SetExtendedFileAttributeW(L"EXT_ATTR.OMF", szCP1252, "EA Value", sizeof("EA Value")))
			PrintConsole(hError, L"SetExtendedFileAttribute(F) returned error %lu\n", dwError = GetLastError());
		do
			if (!SetExtendedFileAttributeW(L"EXT_ATTR.OMF", "EA Name", /* b ? NULL : */ "EA Value", b ? 0UL : sizeof("EA Value")))
				PrintConsole(hError, L"SetExtendedFileAttribute() returned error %lu\n", dwError = GetLastError());
			else
			{
				dwValue = GetExtendedFileAttributeW(L"EXT_ATTR.OMF", "EA Name", cbValue, sizeof(cbValue));

				if (dwValue == 0UL)
					PrintConsole(hError, L"GetExtendedFileAttribute() returned error %lu\n", dwError = GetLastError());
				else
					PrintConsole(hError, L"GetExtendedFileAttribute() returned value \'%hs\' of %lu bytes\n", cbValue, dwValue);

				lpBlock = GetExtendedFileAttributesW(L"EXT_ATTR.OMF");

				if (lpBlock == NULL)
					PrintConsole(hError, L"GetExtendedFileAttributes() returned error %lu\n", dwError = GetLastError());
				else
				{
					lpEA = lpBlock;

					do
						PrintConsole(hError, L"%lu\t%hs = %hs\n", lpEA->NextEntryOffset, lpEA->EaName, lpEA->EaName + 1 + lpEA->EaNameLength);
					while (dwOffset = lpEA->NextEntryOffset, (LPCSTR) lpEA += dwOffset, dwOffset != 0UL);

					if (!FreeExtendedFileAttributes(lpBlock))
						PrintConsole(hError, L"FreeExtendedFileAttributes() returned error %lu\n", dwError = GetLastError());
				}
			}
		while (b ^= TRUE);

		dwValue = GetExtendedFileAttributeA(".", "EA Name", cbValue, sizeof(cbValue));

		if (dwValue == 0UL)
			PrintConsole(hError, L"GetExtendedFileAttribute(\".\", ) returned error %lu\n", dwError = GetLastError());
		else
			PrintConsole(hError, L"GetExtendedFileAttribute(\".\", ) returned value \'%hs\' of %lu bytes\n", cbValue, dwValue);

		if (!SetExtendedFileAttributeA("EXT_ATTR.OMF", "\a\b\f\n\r\t\v", cbValue, sizeof(cbValue)))
			PrintConsole(hError, L"SetExtendedFileAttribute(, \"\\a\\b\\f\\n\\r\\t\\v\", ) returned error %lu\n", dwError = GetLastError());
	}

	ExitProcess(dwError);
}
<<NOKEEP

EXT_ATTR.OMF: EXT_ATTR.MAK
	ML.EXE /Brepro /Fo$@ /nologo /omf /Ta<< /W3 /X
; Copyright (C) 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>

	.model	tiny

; https://support.microsoft.com/en-us/kb/65122

e_header struct				; DOS .EXE header
e_magic	word	5A4Dh			; magic number "MZ"
e_cblp	word	stop - header		; bytes on last page of file
e_cp	word	1			; pages in file
e_crlc	word	0			; number of relocation table entries
e_cparhdr word	sizeof header / 16	; size of header in paragraphs
e_minalloc word	0			; minimum extra paragraphs needed
e_maxalloc word	65535			; maximum extra paragraphs needed
e_ss	word	0			; initial (PSP relative) SS value
e_sp	word	stack - header		; initial (SS relative) SP value
e_csum	word	0			; checksum
e_ip	word	sizeof message		; initial (CS relative) IP value
e_cs	word	0			; initial (PSP relative) CS value
e_lfarlc word	sizeof header		; file address of relocation table
e_ovno	word	0			; overlay number
e_res	word	4 dup (0)		; reserved words
e_oemid	word	5719h			; OEM identifier
e_oeminfo word	2704h			; OEM information
e_res2	word	10 dup (0)		; reserved words
e_lfanew dword	0			; file address of new exe header
e_header ends

	.code

header	e_header <>

message	byte	"(C)opyright 2004-2025, Stefan Kanthak <stefan.kanthak@nexgo.de>", 0Dh, 0Ah, 07h, 24h

start:
	push	cs
	pop	ds
	xor	dx, dx
	mov	ah, 09h
	int	21h

	mov	ax, 4C01h
	int	21h
stop:
	dword	20 dup (?)
stack:
	end	start
<<NOKEEP

EXT_ATTR.DOS: EXT_ATTR.MAK
	CERTUTIL.EXE /DecodeHex /F /V << $@
4D 5A 90 00 01 00 00 00 04 00 00 00 FF FF 00 00   MZ..............
E0 00 00 00 43 00 00 00 40 00 00 00 00 00 00 00   ....C...@.......
00 00 00 00 19 57 04 27 00 00 00 00 00 00 00 00   .....W.'........
00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00   ................
28 43 29 6F 70 79 72 69 67 68 74 20 32 30 30 34   (C)opyright 2004
2D 32 30 32 35 2C 20 53 74 65 66 61 6E 20 4B 61   -2025, Stefan Ka
6E 74 68 61 6B 20 3C 73 74 65 66 61 6E 2E 6B 61   nthak <stefan.ka
6E 74 68 61 6B 40 6E 65 78 67 6F 2E 64 65 3E 0D   nthak@nexgo.de>.
0A 07 24 0E 1F 33 D2 B4 09 CD 21 B8 01 4C CD 21   .....3....!..L.!
<<NOKEEP
